# Task Scheduling in Rust

The goal of this project is to implement a task scheduler in the Rust programming language.

## Background, Motivation, & Potential Impact
Task throughput and latency are two essential metrics in a shared tenant distributed computing platform. The average time that a system requires to process a single unit of work and the number of units of work that can be completed per second are main selling points to enterprise customers who might use such a system. One of the main components of such a system is the mechanism that receives, schedules, and dispatches tasks.

If a scheduler can get tasks assigned to exectors efficiently and intelligently, then a shared tenant computing platform should be able to see significant speed ups.

## Objectives & Features

1. Implement a working task scheduler framework in rust that can execute functions across different physical cores.

2. Build a task API that is natural to use and also allows for light-weight task switching within a single executor.

3. Develop techniques for efficient thread interrupts and shuffles.

4. Enable work stealing between executors for load balancing.

=====

# CS\_4230 Class Project

# https://tinyurl.com/cs4230-students-s18

## WHY

* While the `LRQA`s that you have been performing with perseverance
  help lay the intellectual foundation for a determined and dedicated student of CS_4230
  - **L**ectures 
  - **R**eadings
  - **Q**uizes 
  - **A**ssignments

* What brings the learning experience together is the final project **P**,
  which is so important to this full-semester course that is prominently positioned in the
  course and commands nearly 2 months of focus.

* TYING IT ALL TOGETHER, THE FINAL PROJECT!

## WHAT

* We plan to incorporate 5 innovative aspects:
  - Mentoring
  - Workshop
  - Clinic
  - Final Report/Poster
  - Symposium

* The students of CS_4230 are encouraged to base their final project **P** on problems
  that represent current challenges in the research community.

* To seed this process, the CS_4230 Instructors have proposed problems and here to serve
  you as mentors, during the entire semester and beyond.

## HOW

* Each and every one of you have recieved an Project Page, a shared google document
  we want to start with 
  - Clear specicifation that briefly describes the significance of the application
  - What the mentors would like to accomplish with the student teams on the application
  - The technical skills, particular type of math, physics and chemistry required to understand 
    and work on the application
  - A list of web and traditional resources that students can draw upon technical background
  - General information and building blocks, along with specific URLs to particular implementations
    and Coding Examples.

## PROJECT MENTORING

* Students of CS_4230 are encouraged to contact mentors as frequently as required via Canvas or in-person
* Once students and the mentors agree on a project, they enter into a collaborative relationship, featuring
  - frequent consultation
  - project reporting
* We, the instuctors, attempt to facilitate the collaborative relationship between students and their mentors
  - making it a very valuable experience for both the mentors and students.

### THE PROJECT WORKSHOP/MEETINGS

* This is the primary vehicle that enables the entire class of CS_4230 to contribute to each others final project
  ideas.
* We have dedicated a set of lecture slots or meetings slots to project workshops/meetings.
  - they are designed for studnets' benefit.
* Students of CS_4230 are not graded during the workshops/meetings in order to keep the atmosphere *nonthreatening*
  but to enable them to focus on a meaningful dialog with the instructors, teaching assistants and the rest of the class.
* The instructors of CS_4230 make a commitment to attend all the presentations and to give useful feedback.
* Students of CS_4230 typically need most help in answering the following 3 questions
    
1. Are the projects too big or too small for the amount of time avaiable ?
2. Is there existing work in the field that your CS_4230 class project can benefit from ?
3. The computations being targeted for parallel execution appropriate for which model pthreads/OpenMP/MPI/TBB or CUDA ?
   - hybrid ? 

### THE PROJECT CLINIC

* Specific details soon to be here.

### THE PROJECT DESIGN DOCUMENT

* Once the students decide on a project (or form a team), they are required to update their project page
  - with a design specification section
* Why ? This helps you think through the projects steps before you jump into it.
* The ability to do such planning will be important to your career success.
* The design design document should discuss
  - The background for the project
  - The motivation for the project
  - Application-level objectives
  - Potential impact
  - Main features of the end application
  - An overview of the design
  - An Implementation plan
  - Performance goals
  - A Verification plan
  - An Acceptance test
  - A Project schedule

* The project meetings help ensure that students are on track and that they have
  identified the potential roadblocks early in the process.

* Students of CS_4230 are requested and required to come to meetings with sufficient
  preparation
  - Serial CPU implementation.
    - The best CPU sequential code in terms of performance
    - Preferable with AVX and other optimizations that establish a strong serial base of the code for their speed comparisons.

### THE PROJECT REPORT/SYMPOSIUM

* Students of CS_4230 are required to submit a project report on their key findings
* We might have a whole day class symposium, you can use the presentation slot proportional to the class size
* During this presentation, the students highlight the best part of their project report for the benefit 
  of the whole class.
* The presentation accounts for a significant part of studnets' grades.
* Each student must answer questions directed to him/her as individuals.
* The symposium is an opportunity for students to learn to produce a concise presentation
  that motivates their peers to read the full report.
* After their presentation, the students also submit  full report on their final project.


## WHERE

`CS_4230/src/project`



